/// @addtogroup bitSet
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file selector.h
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _SELECTOR_H_
#define _SELECTOR_H_
typedef bool (*selectorType)(const int*);

class HiperSurfSelector{
  int m_direction,m_frequency,m_value;
public:
  HiperSurfSelector(int A_direction,int A_frequency,int A_value=0):m_direction(A_direction),m_frequency(A_frequency),m_value(A_value){}
  bool operator()(const int* coord) const{
    return coord[m_direction] % m_frequency == m_value;
  }
};

#endif // _SELECTOR_H_

/// @}
