// @addtogroup rounding
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file intRounding.h
///
/// @author Tomasz Kapela
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2007 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _INT_ROUNDING_H_
#define _INT_ROUNDING_H_

namespace capd{
namespace rounding{
 
//////////////////////////////////////////////////////////////////////////////
//   IntRounding
///
///  Definition of class that virtually switches rounding modes of integer numbers
///  because in this case no switching is needed (all operations are exact)
///
///   @author Tomasz Kapela   @date 11-01-2006
//////////////////////////////////////////////////////////////////////////////
class IntRounding{

public:
  IntRounding();            ///<  Call initialization of Floating Point Unit

  static void roundNearest(){  ///<  Sets rounding to nearest mode
  }   
  static void roundUp(){       ///<  Sets rounding up mode
  }
  static void roundDown(){     ///<  Sets rounding down mode
  }
  static void roundCut(){      ///<  Sets rounding towards zero mode
  }
};

}} // namespace capd::rounding

#endif //_INT_ROUNDING_H_

