/// @addtogroup rounding
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file rounding/linux.h
///
/// @author Mikolaj Zalewski
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.


// LINUX code designed by Mikolaj Zalewski

namespace capd{
namespace rounding{

inline void DoubleRounding::roundNearest()
{
  short s;
  asm volatile (
    "fstcw %0\n\t"
    "andw $0xf3ff, %1\n\t"
    "orw $0x0000 , %1\n\t"
    "fldcw %1"
    :"=m" (s)
    :"m" (s)
  );
}

inline void DoubleRounding::roundUp()
{
  short s;
  asm volatile (
    "fstcw %0\n\t"
    "andw $0xf3ff, %1\n\t"
    "orw $0x0800 , %1\n\t"
    "fldcw %1"
    :"=m" (s)
    :"m" (s)
  );
}

inline void DoubleRounding::roundDown()
{
  short s;
  asm volatile (
    "fstcw %0\n\t"
    "andw $0xf3ff, %1\n\t"
    "orw $0x0400 , %1\n\t"
    "fldcw %1"
    :"=m" (s)
    :"m" (s)
  );
 
}

inline void DoubleRounding::roundCut()
{
  short s;
  asm volatile (
    "fstcw %0\n\t"
    "andw $0xf3ff, %1\n\t"
    "orw $0x0C00 , %1\n\t"
    "fldcw %1"
    :"=m" (s)
    :"m" (s)
  );
}

//needed under WINDOWS with GNU CPP
inline void set_intel_im()
{
    unsigned short s;
    asm volatile (
      "fstcw %0\n\t"
      "orw $0x0001 , %1\n\t"
      "fldcw %1"
      :"=m" (s)
      :"m" (s)
    );
}

inline void clear_intel_im(void)
{
  unsigned short s;
    asm volatile (
      "fstcw %0\n\t"
      "andw $0xfffe , %1\n\t"
      "fldcw %1"
      :"=m" (s)
      :"m" (s)
    );
}

}} // namespace capd::rounding

/// @}
