/// @addtogroup setarth
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file henon3.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#include "vectalg/vectalglib.h"
#include "henon3.h"

#if (DIM == 3)

intervalVector Henon3::Phi(const intervalVector &iv) const
{
	intervalVector result;
	result[0] = iv[1] + interval(1.) - a*iv[0]^2;
	result[1] = b*iv[0];
	result[2] = iv[2];
	return result;
}


intervalMatrix Henon3::JacPhi(const intervalVector &iv) const
{
	intervalMatrix result;

/*
    result(1,1)=-2*a*iv(1);
    result(1,2)=1;
    result(2,1)=b;
    result(2,2)=0;
*/
	result[0][0] = interval(-2.)*a*iv[0];
	result[0][1] = interval(1.);
	result[1][0] = b;
	result[1][1] = interval(0.);
	result[2][2] = interval(1.);

	return result;
}

#endif

/// @}
